/**
 * 最初の著者:: トゥイー
 * リポジトリ情報:: $Id: CloseMap.hpp 11 2011-05-14 02:11:18Z yutaka_at_home $
 * 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
 * ライセンス:: CPL(Common Public Licence)
 */

#ifndef _UTILITY_CLOSE_MAP_HPP_
#define _UTILITY_CLOSE_MAP_HPP_

#include "tops/utilities/CloseContainer/CloseContainer.hpp"
#include "tops/utilities/CloseContainer/CloseRelationImpl.hpp"

#include <map>

namespace Utility {

	/**
	 * 密マップテンプレートです。
	 * このテンプレートは、型引数にキー型と密コンテナ要素のポインタ型（スマートポインタ可）を必要とします。
	 * キー型には任意の型を指定できます。
	 * 密コンテナ要素のポインタ型に必要となる性質を以下に示します。
     *
     * 1. CloseContainerElement のポインタ（もしくはスマートポインタ）であること。
	 *
	 * この密マップテンプレートは、実装に STL の std::map を利用しています。
	 *
	 * @author トゥイー
	 */
	template<typename KeyType, typename PtrType>
	class CloseMap : public CloseContainer {
	private:
		typedef std::map<KeyType, PtrType> ValueMap;
		ValueMap m_values;
		typedef std::pair<KeyType, PtrType> ValuePair;

	public:
		/**
		 * 反復子型です。
		 */
		typedef typename ValueMap::iterator iterator;

		/**
		 * 定数反復子型です。
		 */
		typedef typename ValueMap::const_iterator const_iterator;

	public:
		/**
		 * マップを構築します。
		 */
		CloseMap() {
		}

		/**
		 * マップを破棄します。
		 */
		~CloseMap() {
			clear();
		}

	public:
		/**
		 * 空かどうかを判断します。
		 *
		 * @return 空の場合は true、それ以外の場合は false。
		 */
		bool empty() const {
			return m_values.empty();
		}

		/**
		 * キーの存在数（０または１）を返します。
		 *
		 * @param key キー。
		 * @return キーが存在する場合は１、それ以外の場合は０。
		 */
		size_t count(const KeyType& key) const {
			return m_values.count();
		}

		/**
		 * サイズを取得します。
		 *
		 * @return サイズ。
		 */
		size_t size() const {
			return m_values.size();
		}

		/**
		 * 要素列の先頭を示す反復子を取得します。
		 *
		 * @return 反復子。
		 */
		iterator begin() {
			return m_values.begin();
		}

		/**
		 * 要素列の先頭を示す定数反復子を取得します。
		 *
		 * @return 定数反復子。
		 */
		const_iterator begin() const {
			return m_values.begin();
		}

		/**
		 * 要素列の末尾を示す反復子を取得します。
		 *
		 * @return 反復子。
		 */
		iterator end() {
			return m_values.end();
		}

		/**
		 * 要素列の末尾を示す定数反復子を取得します。
		 *
		 * @return 定数反復子。
		 */
		const_iterator end() const {
			return m_values.end();
		}

	public:
		/**
		 * 全ての要素を削除します。
		 */
		void clear() {
			while (!empty()) {
				iterator i = begin();
				i->second->release(*this);
			}
		}

	public:
		/**
		 * キーに対応する反復子を取得します。
		 *
		 * @param key キー。
		 * @return 反復子。キーに対応する反復子が見つからなかった場合は end()。
		 */
		iterator find(const KeyType& key) {
			return m_values.find(key);
		}

		/**
		 * キーに対応する定数反復子を取得します。
		 *
		 * @param key キー。
		 * @return 定数反復子。キーに対応する反復子が見つからなかった場合は end()。
		 */
		const_iterator find(const KeyType& key) const {
			return m_values.find(key);
		}

	public:
		/**
		 * キーを指定して値を取得します。
		 *
		 * @param key キー。
		 * @return キーに対応する値が存在する場合はその値、それ以外の場合は NULL。
		 */
		PtrType operator[](const KeyType& key) const {
			const_iterator i = m_values.find(key);
			return (i != m_values.end()) ? i->second : PtrType();
		}

		/**
		 * 要素を追加します。
		 * ただし、既にキーに対応する値が存在する場合は追加に失敗します。
		 *
		 * @param pair キーと値のペア。
		 * @return 追加に成功した場合は true、失敗した場合は false。
		 */
		bool insert(const ValuePair& pair) {
			std::pair<iterator, bool> i = m_values.insert(pair);
			if (i.second && !!i.first->second) {
				addRelation(*i.first->second, CloseRelationPtr(new CloseRelationImpl<ValueMap>(
					m_values, i.first, this)));
			}
			return i.second;
		}
	};

}  // namespace Utility

#endif
